> For the complete documentation index, see [llms.txt](https://docs.caf.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.caf.io/caf-sdk/flutter/standalone-modules/faceliveness/source-code.md).

# Source Code

The source code below can also be seen in the [Caf's FaceAuth Flutter Repository](https://github.com/combateafraude/FaceLivenessFlutter/blob/main/face_liveness_example/lib/main.dart)

```dart
import 'package:caf_face_liveness/face_liveness.dart';
import 'package:caf_face_liveness/face_liveness_enums.dart';
import 'package:caf_face_liveness/face_liveness_events.dart';
import 'package:flutter/material.dart';

void main() {
  runApp(const MyApp());
}

class MyApp extends StatefulWidget {
  const MyApp({Key? key}) : super(key: key);

  @override
  State<MyApp> createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  final String _mobileToken = "sample_mobile_token";
  final String _personId = "sample_person_id";

  late final FaceLiveness _faceLiveness;

  @override
  void initState() {
    super.initState();
    _initializeFaceLiveness();
  }

  void _initializeFaceLiveness() {
    _faceLiveness = FaceLiveness(mobileToken: _mobileToken, personId: _personId);
    _faceLiveness.setStage(CafStage.prod);
    _faceLiveness.setCameraFilter(CameraFilter.natural);
    _faceLiveness.setEnableScreenshots(true);
    _faceLiveness.setEnableLoadingScreen(false);
  }

  void startFaceLiveness() {
    final stream = _faceLiveness.start();
    _setupFaceLivenessListener(stream);
  }

  void _setupFaceLivenessListener(Stream<FaceLivenessEvent> stream) {
    stream.listen((event) {
      if (event is FaceLivenessEventConnecting) {
        print('Connecting to FaceLiveness...');
      } else if (event is FaceLivenessEventConnected) {
        print('Connected to FaceLiveness.');
      } else if (event is FaceLivenessEventClosed) {
        print('SDK Closed: User canceled the session.');
      } else if (event is FaceLivenessEventSuccess) {
        print('SDK Success! \nSignedResponse: ${event.signedResponse}');
      } else if (event is FaceLivenessEventFailure) {
        print('SDK Failure! \nError type: ${event.errorType} \nError Message: ${event.errorDescription}');
      }
    });
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('FaceLiveness Demo'),
        ),
        body: Center(
          child: ElevatedButton(
            onPressed: () {
              startFaceLiveness();
            },
            child: const Text('Start FaceLiveness'),
          ),
        ),
      ),
    );
  }
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.caf.io/caf-sdk/flutter/standalone-modules/faceliveness/source-code.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
